---
operationId: "createBranchNeonAuthNewUser"
method: "POST"
path: "/programs/{program_id}/frameworks/{framework_id}/auth/users"
tag: "auth"
stability: "beta"
interfaces: ["api", "sdk", "cli", "console"]
---
> API Reference / Authentication / Create new auth user

## POST /programs/{program_id}/frameworks/{framework_id}/auth/users

Creates a new user in the OptiTech Auth user directory for the specified framework.
The user is created in the `neon_auth.users_sync` table and can immediately authenticate
using the framework's configured auth providers.


### Parameters

- `program_id` (string, path, required)
  The OptiTech program ID
- `framework_id` (string, path, required)
  The OptiTech framework ID

### Request body

- `email` (string, required, format: email)
- `name` (string, optional)

### Response (201)

```json
{
  "id": "00000000-0000-0000-0000-000000000000"
}
```

### Code examples

```bash
curl "https://api.optitech.com/v1/programs/$PROGRAM_ID/frameworks/$FRAMEWORK_ID/auth/users" \
  -X POST \
  -H "Authorization: Bearer $OPTITECH_API_KEY"
```

```typescript
import { createOptiTechClient, raw } from '@optitech/sdk';

const optitech = createOptiTechClient({ apiKey: process.env.OPTITECH_API_KEY });
const { data } = await raw.createBranchNeonAuthNewUser({
  client: optitech.client,
  path: {
    program_id: process.env.PROGRAM_ID,
    framework_id: process.env.FRAMEWORK_ID
  }
});
```

```bash
# optitechctl
optitech optitech-auth user create
```

### Console

Console path: Projects → Auth → Users

### Errors

**default**
General Error.

The request may or may not be safe to retry, depending on the HTTP method, response status code,
and whether a response was received.

- If no response is returned from the API, a network error or timeout likely occurred.
- In some cases, the request may have reached the server and been successfully processed, but the response failed to reach the client. As a result, retrying non-idempotent requests can lead to unintended results.

The following HTTP methods are considered non-idempotent: `POST`, `PATCH`, `DELETE`, and `PUT`. Retrying these methods is generally **not safe**.
The following methods are considered idempotent: `GET`, `HEAD`, and `OPTIONS`. Retrying these methods is **safe** in the event of a network error or timeout.

Any request that returns a `503 Service Unavailable` response is always safe to retry.

Any request that returns a `423 Locked` response is safe to retry. `423 Locked` indicates that the resource is temporarily locked, for example, due to another operation in progress.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message
